



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>数据库更新锁WITH UPDLOCK</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">数据库更新锁WITH UPDLOCK</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 16:59:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天因为并发的问题，又讨论了一遍。之前以为同时两个线程开启，线程A加了更新锁，线程B没有加，线程A更新后，线程B也会继续下去代码。但是今天测试了一下，原来线程A更新后（解锁），线程B将不会继续，会出现数据库语句出现修改之类的提示。</p>
<p>写法 SELECT * FROM TABLE WITH UPDLOCK WHERE ID=1</p>
<p>A代码段示例：</p>
<div>
<pre class="prettyprint linenums"> using (TransactionScope trans = new TransactionScope())<br />
                        {<br />
                            using (var dbContext = new Qxun.Activity.DAL.ActivityDbContext())<br />
                            {<br />
string sqlStr = string.Format("SELECT * FROM TABLE WITH(UPDLOCK) WHERE ID={0} ", crossDomainPayRecord.ID);<br />
                                VIPWeRegister046Play model = dbContext.Database.SqlQuery&lt;VIPWeRegister046Play&gt;(sqlStr).FirstOrDefault();

                                if (Status == 0)//说明出现问题<br />
                                {<br />
                                    model.Status = Status;<br />
                                    dbContext.Update&lt;TABLE&gt;(model);<br />
                                    trans.Complete();<br />
                                    return Content(res.ToXml());<br />
                                }<br />
    　　　　　　　　　　　　　　　　trans.Complete();<br />
　　　　　　　　　　　　　　　　}<br />
}
</pre>
</div>
<p>B代码段示例 ：</p>
<div>
<pre class="prettyprint linenums">using (ActivityDbContext dbContext=new ActivityDbContext())<br />
            {<br />
                List&lt;TABLE&gt; model= dbContext.TABLE.ToList();<br />
                foreach (var item in model)<br />
                {<br />
                    item.Status= 2;<br />
　　　　　　　　　　　 dbContext.Insert&lt;Table&gt;(new Table());<br />
                    dbContext.Update&lt;TABLE&gt;(item);<br />
                }<br />
 List&lt;Share&gt; share = dbContext.Shares.ToList();<br />
                if (share.Count == 0)<br />
                {<br />
                    dbContext.Insert&lt;Share&gt;(new Share());<br />
                }<br />
                share = dbContext.Shares.ToList();<br />
                foreach (var item in share)<br />
                {<br />
                    item.MerchantWeixinUserID = 1;<br />
                    dbContext.Update&lt;Share&gt;(item);<br />
                }<br />
            }
</pre>
</div>
<p><strong>1</strong>.线程A进入更新锁代码段，线程B将会停止在dbContext.Update处，不会再继续下去（解锁操作两种：1.更新操作（非事务处理）；2.事务处理结束（处于事务））</p>
<p>接下来有三种情况：</p>
<p>1.1线程A不进行更新操作（没有update操作，即使没有改变值），线程A结束事务后（解锁），线程B将继续运行</p>
<p>1.2线程A进行了更新操作，即此时Status状态值更改为0，线程B将会跳转入异常，异常详细上会有数据库信息更改之类的提示</p>
<p>1.3线程A一直停留在断点，不进行解锁操作，时间一旦达到限制，则线程B将会提示请求超时之类的（由于数据库请求是有设定时限的）</p>
<p><strong>2</strong>.线程A未进入更新锁代码段，则线程B按照正常运行</p>
<p><strong>3</strong>.线程A进入更新锁代码段时，线程B也可以使用select获取，即List&lt;TABLE&gt; model= dbContext.TABLE.ToList();这句会被执行的，直到update操作停止</p>
<p><strong>4</strong>.一旦A线程进入更新锁代码，且进行了update操作，线程B中的插入更新dbContext.Insert&lt;Table&gt;(new Table()); dbContext.Update&lt;TABLE&gt;(item);这两句都不能执行，会出现报错。而share表相关的insert和update也不能运行，这是因为share的代码处理在TABLE下面，此时dbContext已是异常状态。如果将share放置到TABLE代码上方，则会正常运行或者是将share重新开启一个dbContext2进行操作。不过其中应该还有一些缘由...</p>
<p><strong>5</strong>.一旦A线程进入更新锁代码，且未进行update操作，线程B中的插入dbContext.Insert&lt;Table&gt;(new Table());代码是会被执行的，且share相关的代码都会被执行。</p>
<p>异常提示：存储区更新、插入或删除语句影响到了意外的行数(0)。实体在加载后可能被修改或删除。刷新 ObjectStateManager 项。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8eyl3m9.html">A&ast;算法的原理  &amp;lt&semi;转&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gg5e49.html">spi can&amp;&num;39&semi;t create GMem lock</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw1wnk8.html">app整体搭建环境：tabBar切换不同控制器的封装（自定义导航&plus;自定义uiviewcontroler&plus;系统自带tabbar&plus;自定义tabbarController）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkn759.html">读取视屏文件，保存帧图片为ppm文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdr0nz8.html">JS中的className含义</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xw4kv8.html">java---面试题---&period;java&amp;quot&semi;源文件中可以包括多个类（不是内部类）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnxy3z8.html">WPF学习小记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z23m49.html">java和c&num;md5加密不同</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1w0oj9.html">cf459D Pashmak and Parmida&amp;&num;39&semi;s problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydemjmq.html">ubuntu NFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me27ooq.html">web开发相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk55yv8.html">&lbrack;刷题&rsqb;算法竞赛入门经典&lpar;第2版&rpar; 4-4&sol;UVa253 - Cube painting</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyw7ox9.html">year：2017 month：7 day：19</a>
		</li>
						<li><a href="https://www.batexi.com/a/9507zd68.html">动态规划求一个序列的最长回文子序列（Longest Palindromic Substring ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdelnk9.html">Django REST framework中的版本控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z2wmj9.html">Java引用变量的类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj3rxk9.html">第四次作业之jieba库的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv2glj8.html">bzoj千题计划320：bzoj4939&colon; &lbrack;Ynoi2016&rsqb;掉进兔子洞（莫队 &plus; bitset）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv23l0x9.html">&lbrack;SRC初探&rsqb;手持新手卡挖SRC逻辑漏洞心得分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zynood9.html">mybatis核心文件详解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2rrgx9.html">如何实现织梦dedecms表单提交时发送邮箱功能【已解决】</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ogj2g8.html">ASP&period;NET C&num; 实现钉钉签名算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd544v9.html">fastjson转换json字符串key的首字母小写变大写的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy5xzjq.html">&lbrack;JS&rsqb;常见JS错误之一：Uncaught SyntaxError&colon; Unexpected identifier</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r51pddq.html">小程序学习笔记五：API</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw35nk8.html">masonry 基本用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2rm0x9.html">Effective Java 第三版&mdash;&mdash;63&period; 注意字符串连接的性能</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rpx049.html">基于weixin-java-mp  做微信JS签名 invalid signature签名错误 官方说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw3ozd8.html">koa中间件机制详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllk4o0q.html">python环境与PyDev IDE配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
